import java.util.*;

public class KenKen1
{
	public final static int MAXS = 15;
	public final static int EMPTY = 0;
	public final static int NOSQ = -1;

	public static long fact[] = new long[MAXS+1];
	public static int grid[][] = new int[MAXS][MAXS];
	public static int numr, numc;
	public static int pcount;
	public static Scanner in = new Scanner(System.in);

	public static boolean nextEmptySq(int rows, int cols, int newr, int newc, nextSq sq)
	{
		if (++newc == cols) {
			newr++;
			newc=0;
		}
		while (newr < rows) {
			if (grid[newr][newc] == EMPTY) {
				sq.newr = newr;
				sq.newc = newc;
				return true;
			}
			if (++newc == cols) {
				newr++;
				newc=0;
			}
		}
		return false;
	}

	public static boolean okToPlace(double v, int r, int c)
	{
		if (grid[r][c] == v)
			return false;
		for(int row=0; row<r; row++) {
			if (grid[row][c] == v)
				return false;
		}
		for(int col=0; col<c; col++) {
			if (grid[r][col] == v)
				return false;
		}
		return true;
	}

	public static void countPlacements(int[] sets, int index, int count, int val, int startr, int startc, int firstr, int firstc, boolean first, int numr, int numc)
	{
		if (index == -1 || sets[index] == 1) {
			pcount++;
			return;
		}
		if (numr-startr < sets[index]-count)
			return;
		int r = startr, c = startc;
		nextSq sq = new nextSq();
		while (nextEmptySq(numr, numc, r, c, sq)) {
			r = sq.newr;
			c = sq.newc;
			if (okToPlace(val, r, c)) {
				grid[r][c] = val;
				int newIndex = index;
				int newCount = count+1;
				int newStartr = r+1;
				int newStartc = -1;
				if (first) {
					firstr = r;
					firstc = c;
				}
				if (newCount == sets[index]) {	// end of a placement
/*
for(int i=0; i<numr; i++) {
for(int j=0; j<numc; j++)
if (grid[i][j] == EMPTY) System.out.print('.'); else if (grid[i][j] == NOSQ) System.out.print('X'); else System.out.print(grid[i][j]);
System.out.println();
}
System.out.println();
/**/
					newIndex = index-1;
					newCount = 0;
					if (newIndex >= 0 && sets[newIndex+1] == sets[newIndex]) {
						newStartr = firstr;
						newStartc = firstc;
						countPlacements(sets, newIndex, newCount, val+1, newStartr, newStartc, firstr, firstc, true, numr, numc);
					}
					else {
						newStartr = 0;
						newStartc = -1;
						countPlacements(sets, newIndex, newCount, val+1, newStartr, newStartc, firstr, firstc, true, numr, numc);
					}
				}
				else {
					countPlacements(sets, newIndex, newCount, val, newStartr, newStartc, firstr, firstc, false, numr, numc);
				}
				grid[r][c] = EMPTY;
			}
		}
	}

	public static long countPlacements(int comps[], int size, int numr, int numc)
	{
		int sets[] = new int [MAXS], reps[] = new int[10];
		int count = 1;
		for(int i=1; i<size; i++) {
			if (comps[i-1] == comps[i]) {
				count++;
				if (count > numr || count > numc)
					return 0;
			}
			else {
				reps[count]++;
				count = 1;
			}
		}
		reps[count]++;
		int m=0;
		for(int i=1; i<=9; i++) {
			for(int j=0; j<reps[i]; j++)
				sets[m++] = i;
		}
/*
System.out.print("  ");
for(int i=0; i<m; i++)
System.out.print(sets[i] + ',');
System.out.println();
/**/

		pcount = 0;
		countPlacements(sets, m-1,  0,  1,  0,  -1,  0,  0, true,  numr,  numc);
		long ans = pcount;
		int rep = 1;
		for(int i=1; i<m; i++) {
			if (sets[i-1] == sets[i])
				rep++;
			else {
				ans *= fact[rep];
				rep = 1;
			}
		}
		return ans*fact[rep];
	}

	public static void input(int m)
	{
		int minr, minc, maxr, maxc, r, c;
		int rlist[] = new int[MAXS], clist[] = new int[MAXS];
		r = in.nextInt();
		c = in.nextInt();
		rlist[0] = minr = maxr = r;
		clist[0] = minc = maxc = c;
		for(int i=1; i<m; i++) {
			r = in.nextInt();
			c = in.nextInt();
			if (r < minr)
				minr = r;
			else if (r > maxr)
				maxr = r;
			if (c < minc)
				minc = c;
			else if (c > maxc)
				maxc = c;
			rlist[i] = r;
			clist[i] = c;
		}
		numr = maxr-minr+1;
		numc = maxc-minc+1;
		for(r=0; r<numr; r++)
			for(c=0; c<numc; c++)
				grid[r][c] = NOSQ;
		for(int i=0; i<m; i++) {
			grid[rlist[i]-minr][clist[i]-minc] = EMPTY;
		}
	}

	public static int numSub(int target, int n)
	{
		if (target <= 0 || target >= n)
			return 0;
		else
			return 2*(n-target);
	}

	public static int numDiv(int target, int n)
	{
		if (target <= 1)
			return 0;
		else
			return 2*(n/target);
	}

	public static long numAdd(int target, int n, int numsq, int comps[], int nc)
	{
		if (target == 0 && nc == numsq) {
//for(int i=0; i<numsq; i++) System.out.print(comps[i] + ','); System.out.println();
			return countPlacements(comps, numsq, numr, numc);
		}
		else if (n == 1) {
			if (target == numsq-nc) {
				for(int i=nc; i<numsq; i++)
					comps[i] = 1;
//for(int i=0; i<numsq; i++) System.out.print(comps[i] + ','); System.out.println();
				return countPlacements(comps, numsq, numr, numc);
			}
			else
				return 0;
		}
		else {
			long ans = numAdd(target, n-1, numsq, comps, nc);
			while (target-n >= 0 && nc < numsq) {
				target -= n;
				comps[nc++] = n;
				ans += numAdd(target, n-1, numsq, comps, nc);
			}
			return ans;
		}
	}

	public static long numMul(int target, int n, int numsq, int comps[], int nc)
	{
		if (target == 1) {
			for(int i=nc; i<numsq; i++)
				comps[i] = 1;
//for(int i=0; i<numsq; i++) System.out.print(comps[i] + ',')); System.out.println();
			return countPlacements(comps, numsq, numr, numc);
		}
		else if (n == 1)
			return 0;
		else {
			long ans = numMul(target, n-1, numsq, comps, nc);
			while (target%n == 0 && nc < numsq) {
				target /= n;
				comps[nc++] = n;
				ans += numMul(target, n-1, numsq, comps, nc);
			}
			return ans;
		}
	}

	public static void main(String [] args)
	{
		int n, m, target;
		char op;
		int comps[] = new int[MAXS];

		fact[1] = 1;
		for(int i=2; i<=MAXS; i++) {
			fact[i] = i*fact[i-1];
		}
		n = in.nextInt();
			m = in.nextInt();
			target = in.nextInt();
			op = in.next().charAt(0);
			input(m);
			switch (op) {
			case '-' : System.out.print( numSub(target, n)); break;
			case '/' : System.out.print( numDiv(target, n)); break;
			case '+' : System.out.print( numAdd(target, n, m, comps, 0)); break;
			case '*' : System.out.print( numMul(target, n, m, comps, 0)); break;
			}
			System.out.println();

//	int sets[MAXS] = {1, 1, 1, 1, 1, 2};
//	long ans = countPlacements(sets, 6, numr, numc);
//	System.out.print(ans + endl);
	}
}

class nextSq
{
	public int newr, newc;
}
