#include <iostream>
#include <iomanip>
using namespace std;

const int MAXS = 15;
const int EMPTY = 0;
const int NOSQ = -1;

long fact[MAXS+1];
int grid[MAXS][MAXS];
int	numr, numc;
int pcount;

bool nextEmptySq(int rows, int cols, int& newr, int& newc)
{
	if (++newc == cols) {
		newr++;
		newc=0;
	}
	while (newr < rows) {
		if (grid[newr][newc] == EMPTY)
			return true;
		if (++newc == cols) {
			newr++;
			newc=0;
		}
	}
	return false;
}

bool okToPlace(double v, int r, int c)
{
	if (grid[r][c] == v)
		return false;
	for(int row=0; row<r; row++) {
		if (grid[row][c] == v)
			return false;
	}
	for(int col=0; col<c; col++) {
		if (grid[r][col] == v)
			return false;
	}
	return true;
}

void countPlacements(int sets[], int index, int count, int val, int startr, int startc, int firstr, int firstc, bool first, int numr, int numc)
{
	if (index == -1 || sets[index] == 1) {
		pcount++;
		return;
	}
	if (numr-startr < sets[index]-count)
		return;
	int r = startr, c = startc;
	while (nextEmptySq(numr, numc, r, c)) {
		if (okToPlace(val, r, c)) {
			grid[r][c] = val;
			int newIndex = index;
			int newCount = count+1;
			int newStartr = r+1;
			int newStartc = -1;
			if (first) {
				firstr = r;
				firstc = c;
			}
			if (newCount == sets[index]) {	// end of a placement
/*
for(int i=0; i<numr; i++) {
for(int j=0; j<numc; j++)
if (grid[i][j] == EMPTY) cout << '.'; else if (grid[i][j] == NOSQ) cout << 'X'; else cout << grid[i][j];
cout << endl;
}
cout << endl;
/**/
				newIndex = index-1;
				newCount = 0;
				if (newIndex >= 0 && sets[newIndex+1] == sets[newIndex]) {
					newStartr = firstr;
					newStartc = firstc;
					countPlacements(sets, newIndex, newCount, val+1, newStartr, newStartc, firstr, firstc, true, numr, numc);
				}
				else {
					newStartr = 0;
					newStartc = -1;
					countPlacements(sets, newIndex, newCount, val+1, newStartr, newStartc, firstr, firstc, true, numr, numc);
				}
			}
			else {
				countPlacements(sets, newIndex, newCount, val, newStartr, newStartc, firstr, firstc, false, numr, numc);
			}
			grid[r][c] = EMPTY;
		}
	}
}

long countPlacements(int comps[], int size, int numr, int numc)
{
	int sets[MAXS] = {0}, reps[10] = {0};
	int count = 1;
	for(int i=1; i<size; i++) {
		if (comps[i-1] == comps[i]) {
			count++;
			if (count > numr || count > numc)
				return 0;
		}
		else {
			reps[count]++;
			count = 1;
		}
	}
	reps[count]++;
	int m=0;
	for(int i=1; i<=9; i++) {
		for(int j=0; j<reps[i]; j++)
			sets[m++] = i;
	}
/*
cout << "  ";
for(int i=0; i<m; i++)
cout << sets[i] << ',';
cout << endl;
/**/

	pcount = 0;
	countPlacements(sets, m-1,  0,  1,  0,  -1,  0,  0, true,  numr,  numc);
	long ans = pcount;
	int rep = 1;
	for(int i=1; i<m; i++) {
		if (sets[i-1] == sets[i])
			rep++;
		else {
			ans *= fact[rep];
			rep = 1;
		}
	}
	return ans*fact[rep];
}

void input(int m)
{
	int minr, minc, maxr, maxc, r, c;
	int rlist[MAXS], clist[MAXS];
	cin >> r >> c;
	rlist[0] = minr = maxr = r;
	clist[0] = minc = maxc = c;
	for(int i=1; i<m; i++) {
		cin >> r >> c;
		if (r < minr)
			minr = r;
		else if (r > maxr)
			maxr = r;
		if (c < minc)
			minc = c;
		else if (c > maxc)
			maxc = c;
		rlist[i] = r, clist[i] = c;
	}
	numr = maxr-minr+1;
	numc = maxc-minc+1;
	for(int r=0; r<numr; r++)
		for(int c=0; c<numc; c++)
			grid[r][c] = NOSQ;
	for(int i=0; i<m; i++) {
		grid[rlist[i]-minr][clist[i]-minc] = EMPTY;
	}
}

int numSub(int target, int n)
{
	if (target <= 0 || target >= n)
		return 0;
	else
		return 2*(n-target);
}

int numDiv(int target, int n)
{
	if (target <= 1)
		return 0;
	else
		return 2*(n/target);
}

long numAdd(int target, int n, int numsq, int comps[], int nc)
{
	if (target == 0 && nc == numsq) {
//for(int i=0; i<numsq; i++) cout << comps[i] << ','; cout << endl;
		return countPlacements(comps, numsq, numr, numc);
	}
	else if (n == 1) {
		if (target == numsq-nc) {
			for(int i=nc; i<numsq; i++)
				comps[i] = 1;
//for(int i=0; i<numsq; i++) cout << comps[i] << ','; cout << endl;
			return countPlacements(comps, numsq, numr, numc);
		}
		else
			return 0;
	}
	else {
		long ans = numAdd(target, n-1, numsq, comps, nc);
		while (target-n >= 0 && nc < numsq) {
			target -= n;
			comps[nc++] = n;
			ans += numAdd(target, n-1, numsq, comps, nc);
		}
		return ans;
	}
}
long numMul(int target, int n, int numsq, int comps[], int nc)
{
	if (target == 1) {
		for(int i=nc; i<numsq; i++)
			comps[i] = 1;
//for(int i=0; i<numsq; i++) cout << comps[i] << ','; cout << endl;
		return countPlacements(comps, numsq, numr, numc);
	}
	else if (n == 1)
		return 0;
	else {
		long ans = numMul(target, n-1, numsq, comps, nc);
		while (target%n == 0 && nc < numsq) {
			target /= n;
			comps[nc++] = n;
			ans += numMul(target, n-1, numsq, comps, nc);
		}
		return ans;
	}
}

int main()
{
	int n, m, target;
	char op;
	int comps[MAXS];

	fact[1] = 1;
	for(int i=2; i<=MAXS; i++) {
		fact[i] = i*fact[i-1];
	}
	cin >> n;
		cin >> m >> target >> op;
		input(m);
		switch (op) {
		case '-' : cout << numSub(target, n); break;
		case '/' : cout << numDiv(target, n); break;
		case '+' : cout << numAdd(target, n, m, comps, 0); break;
		case '*' : cout << numMul(target, n, m, comps, 0); break;
		}
		cout << endl;
//	int sets[MAXS] = {1, 1, 1, 1, 1, 2};
//	long ans = countPlacements(sets, 6, numr, numc);
//	cout << ans << endl;
}
